#version 330 core
in vec4 FragPos;

uniform vec3 lightPos;
uniform float far_plane;
uniform float near_plane;

void main()
{
	float lightDistance = distance(FragPos.xyz, lightPos);

	// map to [0;1]
	lightDistance = (lightDistance - near_plane) / (far_plane - near_plane);

	// Write modified depth
	gl_FragDepth = lightDistance;
}