#version 330 core
layout (triangles) in; // 1 triangle
layout (triangle_strip, max_vertices=18) out; // 6 triangles (one for each face)

uniform mat4 shadowTransforms[6];

out vec4 FragPos; // FragPos from GeomShader (output per emitvertex)

void main()
{
	// gl_Layer is built-in variable that specifies to which face we render.
    for(gl_Layer = 0; gl_Layer < 6; ++gl_Layer)
    {
        for(int i = 0; i < 3; ++i) // for each triangle's vertices
        {
            FragPos = gl_in[i].gl_Position;
            gl_Position = shadowTransforms[gl_Layer] * FragPos;
            EmitVertex();
        }    
        EndPrimitive();
    }
} 